from cgi import escape
import re
import random

urlchars = r'[A-Za-z0-9/:@_%~#=&\.\-\?]+'
url = r'["=]?((http|ftp|https|irc|telnet):%s)' % urlchars
example = """At http://www.python.org you can see things.
At ftp://ftp.python.org you can download things.
At https://www.python.org you can't find anything!"""

def hyperlink_urls(text):
    """Replaces all URLs in the text with HTML hyperlinks."""
    regexp = re.compile(url, re.I|re.S)
    def replace(match):
        url = match.groups()[0]
        return create_hyperlink(url, url)
    text = regexp.subn(replace, text)[0]
    return text

def create_hyperlink(url, title, size=60, etc="...",
                     klass=None, **keywords):
    """Creates a hyperlink."""
    div = ""
    if size:
        if len(title) > size:
            #div_id = "hyperlink_%s" % int(random.random() * 1000000000)
            #div = """<div class="hidden" id="%s">%s</div>""" % (div_id, title)
            #if not keywords.has_key('onmouseover'):
            #    keywords['onmouseover'] = "show('%s')" % div_id
            #    keywords['onmouseout'] = "hide('%s')" % div_id
            title = title[:size] + etc
    if klass is not None:
        keywords['class'] = klass
    title = escape(title)
    attributes = ""
    if keywords:
        for key, value in keywords.items():
            attributes += '%s="%s" ' % (key, value)
        else:
            attributes = attributes[:-1]
    return div + '<a href="%s" %s>%s</a>' % (url, attributes, title)

def log(message):
    print message

if __name__ == '__main__':
    print hyperlink_urls(example)
